import java.awt.*;
import java.applet.*;
import java.io.*;
import java.net.*;
import java.util.*;

////////////////////////////////////////////////////////////////////
//
//              CLASS : selectedInfoWin
//              ===================
//     the window is used for showing the selected machines.
////////////////////////////////////////////////////////////////////
 

class selectedInfoWin extends Frame {
  private int vwWidth = 500, vwHeight = 400;
  private TextArea data;
  int pos = 0;
  private Button close, show;

  private String urlstr;
  private DataInputStream datas = null;
  private loadThread loadthread = null;
  private vdceapp father = null;

  public selectedInfoWin(vdceapp father, String urlstr) {
    super();
    this.urlstr = urlstr;
    this.father = father;

    System.out.println("enter the Selected Machine VisualWin...");
    setTitle("Selected Machine Information Window");
    setLayout(new BorderLayout());
    data = new TextArea("\n", 20, 76);
    Font newf = new Font("Courier", Font.PLAIN, 18);
    data.setFont(newf);
    add("North", data);
    data.setEditable(false);

    Panel p = new Panel();
    add("South", p);
    show  = new Button("SelectedMachine");
    close = new Button("CLOSE");
    p.add(show);
    p.add(new Label("  "));
    p.add(close);
    resize(vwWidth, vwHeight);
    pack();
    show();
  }

    private String make_spaces(int num) {
	String spaces = "";
	if (num > 0) 
	for (int i = 0; i < num; i ++)
	     spaces += " ";
	return spaces;
     }

  public boolean action(Event evt, Object obj) {
    DataInputStream datas = null;
    int pos = 0;
    URL url = null;

     if (evt.target instanceof Button) {
         if ("CLOSE".equals(obj)) {
             System.out.println("CLOSE");
	     dispose();
             return true;
	 }
         if ("SelectedMachine".equals(obj)) {
	   System.out.println("Show the selected machine");
	   String titleStr = "____________________________________________________________________________\n";
	   data.insertText(titleStr, pos);
	   pos += titleStr.length();
	   titleStr = "Task   MACHINE_NAME      OS_NAME    LOAD      PROCESS    TOTAL_MEM    FREE_MEM \n";
	   data.insertText(titleStr, pos);
	   pos += titleStr.length();
	   titleStr = "----------------------------------------------------------------------------\n";
	   data.insertText(titleStr, pos);

	   pos += titleStr.length();
	   int run_pos = pos;
	   String aline = null;
	   try {
	     url = new URL(urlstr);
	   }  catch (MalformedURLException e1) {
	     System.out.println("ERROR in: invoking servlet SelectedVisual");
	   }

             try {
                 datas = new DataInputStream(url.openStream());
              }  catch (IOException e)
                    { System.out.println("Error in opening data stream of loadInfoServ");}

             try {
		 String task_no, mach_name, domain_name, cluster_name, os_name;
		 String load, proc_num, total_mem, avail_mem;
		 int index;
                 while ((aline = datas.readLine()) != null) {

			index = aline.indexOf(" ");
			task_no = aline.substring(0, index);
			task_no += make_spaces(4-task_no.length());
		    	aline = aline.substring(index+1, aline.length());

			index = aline.indexOf(" ");
			mach_name = aline.substring(0, index);
			mach_name += make_spaces(12-mach_name.length());
		    	aline = aline.substring(index+1, aline.length());

			index = aline.indexOf(" ");
			load = aline.substring(0, index);
			load += make_spaces(4-load.length());
		    	aline = aline.substring(index+1, aline.length());

			index = aline.indexOf(" ");
			os_name = aline.substring(0, index);
			os_name += make_spaces(6-os_name.length());
		    	aline = aline.substring(index+1, aline.length());

			index = aline.indexOf(" ");
			proc_num = aline.substring(0, index);
			proc_num += make_spaces(6 - proc_num.length());
		    	aline = aline.substring(index+1, aline.length());

			index = aline.indexOf(" ");
			total_mem = aline.substring(0, index);
			total_mem += make_spaces(8 -total_mem.length());

		    	avail_mem = aline.substring(index+1, aline.length());
			avail_mem += make_spaces(8 -avail_mem.length());

			aline = task_no + "     " + mach_name + "  |  " + os_name 
			      + "  |  " + load + "   |  " + proc_num + "  |  " 
			      + total_mem + "  |  " + avail_mem + "\n";

/*
		   index = aline.indexOf(" ");
		   total_task = aline.substring(0, index);
		   System.out.println("Task Number : " + total_task);

		   machine_name = aline.substring(index+1, aline.length());
		   System.out.println("machine name : " + machine_name);

		   aline = total_task + machine_name + "\n";
*/

			data.insertText(aline, run_pos);
                        run_pos += aline.length();
		 }
                 datas.close();
//		 lwin.pos = run_pos;
             }  catch (IOException e)
                    { System.out.println("Error in reading load info "); }


	 }
	 return true;
     }
     return false;
  }
}
